zoukankan      html  css  js  c++  java
  • POJ 1564 Sum It Up (DFS+剪枝)

    
                                                                                                                  Sum It Up
    Time Limit: 1000MS   Memory Limit: 10000K
    Total Submissions: 5820   Accepted: 2970

    Description

    Given a specified total t and a list of n integers, find all distinct sums using numbers from the list that add up to t. For example, if t = 4, n = 6, and the list is [4, 3, 2, 2, 1, 1], then there are four different sums that equal 4: 4, 3+1, 2+2, and 2+1+1. (A number can be used within a sum as many times as it appears in the list, and a single number counts as a sum.) Your job is to solve this problem in general.

    Input

    The input will contain one or more test cases, one per line. Each test case contains t, the total, followed by n, the number of integers in the list, followed by n integers x 1 , . . . , x n . If n = 0 it signals the end of the input; otherwise, t will be a positive integer less than 1000, n will be an integer between 1 and 12 (inclusive), and x 1 , . . . , x n will be positive integers less than 100. All numbers will be separated by exactly one space. The numbers in each list appear in nonincreasing order, and there may be repetitions.

    Output

    For each test case, first output a line containing `Sums of', the total, and a colon. Then output each sum, one per line; if there are no sums, output the line `NONE'. The numbers within each sum must appear in nonincreasing order. A number may be repeated in the sum as many times as it was repeated in the original list. The sums themselves must be sorted in decreasing order based on the numbers appearing in the sum. In other words, the sums must be sorted by their first number; sums with the same first number must be sorted by their second number; sums with the same first two numbers must be sorted by their third number; and so on. Within each test case, all sums must be distinct; the same sum cannot appear twice.

    Sample Input

    4 6 4 3 2 2 1 1
    5 3 2 1 1
    400 12 50 50 50 50 50 50 25 25 25 25 25 25
    0 0

    Sample Output

    Sums of 4:
    4
    3+1
    2+2
    2+1+1
    Sums of 5:
    NONE
    Sums of 400:
    50+50+50+50+50+50+25+25+25+25
    50+50+50+50+50+25+25+25+25+25+25
    


    Source



    思路:因为数量少。能够暴力搜索解决。

    DFS。值得注意的地方是去重,我用的是和上一递归pre比較。假设同样则减枝。



    #include<iostream>
    #include<cstdio>
    
    using namespace std;
    
    int num[15],ans[15];
    int flag,t,n;
    
    void dfs(int now,int sum,int cur)
    {
        if(sum==0)
        {
            flag=1;
            printf("%d",ans[0]);
            for(int i=1;i<cur;i++)
            {
                printf("+%d",ans[i]);
            }
            printf("
    ");
            return;
        }
        else
        {
            int pre=-1;
            for(int i=now;i<n;i++)
            {
                if(sum>=num[i]&&num[i]!=pre)
                {
                    pre=num[i];                       //此处与上一次递归的num[i],即pre,作比較。
                    ans[cur]=num[i];
                    dfs(i+1,sum-num[i],cur+1);
                }
            }
        }
    }
    
    
    
    int main()
    {
        while(scanf("%d%d",&t,&n),n&&t)
        {
            flag=0;
            printf("Sums of %d:
    ",t);
            for(int i=0;i<n;i++)
                scanf("%d",num+i);
            dfs(0,t,0);
    
            if(!flag)
                printf("NONE
    ");
        }
    
        return 0;
    
    }
    

           
    不知道。我理解得,对不正确。每条递归路线互不影响。

    即一个数组ans[15],并没有什么值得覆盖问题。

  • 相关阅读:
    【BZOJ 3732】 Network
    【BJOI 2018】 求和
    【HDU 1005】 Number Sequence
    【HDU 3652】 B-numbers
    【SCOI 2007】 降雨量
    BZOJ2186 SDOI2008沙拉公主的困惑(数论)
    #38 游戏(线段树)
    BZOJ2339 HNOI2011卡农(动态规划+组合数学)
    BZOJ3107 CQOI2013二进制A+B(动态规划)
    BZOJ3083 遥远的国度(树链剖分+线段树)
  • 原文地址:https://www.cnblogs.com/zhchoutai/p/6711066.html
Copyright © 2011-2022 走看看